<template>
  <client-only>
    <file-pond
      ref="pond"
      label-idle="Arrastra y suelta aquí el archivo a cargar <br>
                  <span class=&quot;filepond--label-action&quot;> Aquí </span>
                  <p>Archivos soportados: csv, xlsx</p>"
      :accepted-file-types="typesAllowed"
      :allow-multiple="false"
      @addfile="handleFile"
      @processfileabort="handleFile"
      @processfileundo="handleFile"
      @removefile="handleFile"
    />
  </client-only>
</template>

<script>
import vueFilePond from 'vue-filepond';
import 'filepond/dist/filepond.min.css';

import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type';

const FilePond = vueFilePond(
  FilePondPluginFileValidateType,
);

export default {
  name: 'FilePondUpload',
  components: {
    FilePond,
  },
  props: {
    fileTypesAllowed: {
      type: Array,
      default: () => [
        'application/vnd.ms-excel',
        'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        'application/vnd.ms-excel',
      ],
    },
  },
  emits: ['file-uploaded'],
  computed: {
    typesAllowed() {
      return this.fileTypesAllowed.join(', ');
    },
  },
  methods: {
    handleFile() {
      const file = this.$refs.pond.getFile() ?? {};
      this.$emit('file-uploaded', file);
    },
  },
};
</script>

<style>
.filepond--root {
  min-height: 7rem;
  max-height: 30rem;
  background-color: #6c4f4f14;
}
.filepond--drop-label {
  margin: 1rem;
}
</style>
